/*:
 * @plugindesc Adds an additional 'Load Save' option when gameover occurs.
 *
 * @author Draught
 *
 * 
 *
*/
let old_sceneFileCancel = Scene_OmoriFile.prototype.onCommandWindowCancel
Scene_OmoriFile.prototype.onCommandWindowCancel = function() {
  let isGameOver = SceneManager.isPreviousScene(Scene_Gameover)
  old_sceneFileCancel.call(this)
  if (isGameOver) {
    SceneManager._nextScene.skipIntro()
  }
}
Scene_Gameover.prototype.skipIntro = function() {
  this.startFadeIn(0)
  this.__skipped = true
  this._animData.phase = 3
  
}
let old_createRetryWindows = Scene_Gameover.prototype.createRetryWindows
Scene_Gameover.prototype.createRetryWindows = function() {
  old_createRetryWindows.call(this)
  if (!this.__skipped) {return}

  this._retryWindows.forEach(x => {
    x.drawOpacity = 255;
    x.opacity = 255;
    x.contents.paintOpacity = x.drawOpacity;
    x.contents.drawText(x.textToDraw, 0, -4, x.contents.width, x.contents.height, 'center');
  })
  this._retryCursorSprite.opacity = 255;
  this.updateRetryInputCursorPosition(0);
  this._inputData.active = true;
  if ($gameTemp.__retryScreenMePos) {
    // AudioManager.playMe({name: 'xx_gameover', volume: 100, pitch: 100, pan:0});
    // AudioManager.updateMeParameters({name: 'xx_gameover', volume: 100, pitch: 100, pan: 0, pos: $gameTemp.__retryScreenMePos})
  }
  let retryQ = this._retryQuestion
  retryQ.contents.drawText(retryQ.textToDraw, 0, -4, retryQ.contents.width, retryQ.contents.height, 'center');
  retryQ.textDrawn = retryQ.textToDraw
}
yin_gameover_createRetryWindows = function() {
  // Initialize Retry Windows Array
  this._retryWindows = [];
  // List of text
  let offset = 0
  let spacing = 100
  let text = []
  if (this._isFinalBattle) {
    text.push(LanguageManager.getMessageData("XX_SYSTEM.message_10").text)
    text.push(LanguageManager.getMessageData("XX_SYSTEM.message_11").text)
  } else {
    text.push("RETRY")
    text.push("MAIN MENU")
    text.push("LOAD SAVE")
    offset = -110
  }
  // Go Through Text
  for (let i = 0; i < text.length; i++) {
    let win = new Window_Base(0, 0, 0, 0);
    win.standardPadding = function() { return 4; };
    win.initialize(0, 0, win.contents.measureTextWidth(text[i]) + win.standardPadding() * 4, 32)
    win.contents.fontSize = 26;

    win.x = offset + Math.floor(Graphics.boxWidth / 2.6) + i * spacing
    if (!this._isFinalBattle) { spacing += 20 }
    win.y = 380;
    win.drawOpacity = 0;
    win.opacity = 0;
    win.textToDraw = text[i];
    win.update = function(animPhase) {
      if (animPhase == 2) {
        if(!this.parent._retryQuestion.isTextComplete()) {return;}
        if (this.drawOpacity < 255) {
          this.contents.clear();
          this.drawOpacity += 2;
          this.opacity += 2;
          this.contents.paintOpacity = this.drawOpacity;
          win.contents.drawText(this.textToDraw, 0, -4, this.contents.width, this.contents.height, 'center');
        }
      } else if (animPhase == 4) {
        this.contents.clear();
        this.drawOpacity -= 4;
        this.opacity -= 4;
        this.contents.paintOpacity = this.drawOpacity;
        win.contents.drawText(this.textToDraw, 0, -4, this.contents.width, this.contents.height, 'center');
      }
    };
    this._retryWindows.push(win);
    this.addChild(win);
  };
  if (!this._isFinalBattle) {
    let _temp = this._retryWindows[1]
    let _tempUpdate = _temp.update
    let _tempThis = this
    _temp.update = function(phase) {
      _tempUpdate.call(this, phase)
      _tempThis._retryWindows[2].update(phase)
    }
  }
  // Set Max Input
  this._inputData.max = text.length;
  // Create Retry Cursor Sprite
  this._retryCursorSprite = new Sprite_WindowCustomCursor(undefined, 'cursor_menu');
  this._retryCursorSprite.opacity = 0;
  this.addChild(this._retryCursorSprite);
};
Scene_Gameover.prototype.updateRetryInput = function() {
  // Get Input Data
  const input = this._inputData;

  // If Input is Active
  if (input.active) {
    // If Ok input is triggered
    if (Input.isTriggered('ok')) {
      // Play Load sound
      SoundManager.playLoad();
      // Get Animation Object
      const anim = this._animData;

      if (input.index === 0) {
        if (anim.phase == 3) {
          anim.phase = 4;
        };
      } else if (input.index === 1) {
        anim.phase = 8;
        input.active = false;
        this.fadeOutAll()
        anim.delay = 70;
      } else if (input.index === 2) {
        // let _temp = SceneManager.goto
        // SceneManager.goto = function(scene) {
        //   SceneManager.goto = _temp
        //   if (scene === Scene_OmoriTitleScreen) {
        //     // SceneManager.clearStack()
        //     // _temp.call(this, Scene_OmoriFile)
        if (AudioManager._meBuffer) {
          $gameTemp.__retryScreenMePos = AudioManager._meBuffer.seek()
        } else {
          $gameTemp.__retryScreenMePos = 0
        }
        SceneManager.push(Scene_OmoriFile)
        SceneManager._nextScene._canSave = false
        //     // setTimeout(()=>SceneManager.push(Scene_OmoriFile))
        //     // anim.phase = -1;
        //   } else {
        //     _temp.call(this, scene)
        //   }
        // }
      }
      return;
    };

    if (Input.isRepeated('left')) {
      SoundManager.playCursor();
      if (input.index === 0) {
        input.index = input.max - 1
      } else {
        input.index = Math.abs((input.index - 1) % input.max);
      }
      this.updateRetryInputCursorPosition(input.index);
      return
    };
    if (Input.isRepeated('right')) {
      SoundManager.playCursor();
      input.index = (input.index + 1) % input.max;
      this.updateRetryInputCursorPosition(input.index);
      return
    };
  };
};